;
; cat.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; cat [files]
;;
;; 	Concatenates binary files.
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= 1

bufp		= $fd
buffsize	= $4000

		.include "lib.asm"

banner		.null 13,"cat 0.1 by soci/singular",13

start2		ldx #<arglist
		ldy #>arglist
		jsr parseargs
		lda #<arglist
		sta p1
		lda #>arglist
		sta p1+1

loop		ldy #0
		lda (p1),y
		bne +
q		jmp exit

+		ldx p1
		ldy p1+1
		pha
		sec
		adc p1
		sta p1
		bcc +
		inc p1+1
+		pla
		inx
		bne +
		iny
+		jsr onefile
		ldx $91
		cpx #$7f
		beq q
		jmp loop

onefile		jsr $ffbd
		lda #1
		ldx mydrive
		ldy #0
		jsr $ffba
		jsr $ffc0

		lda #<buffer
		sta bufp
		lda #>buffer
		sta bufp+1

lp		ldx #1
		stx myin
		jsr $ffc6

		lda #bufp
		.cerror <buffsize
		ldx #0
		ldy #>buffsize
		jsr read
		bcs ejj
		txa
		pha
		tya
		pha

		ldx #3
		stx myout
		jsr $ffc9

		pla
		tay
		pla
		tax
		lda #bufp
		jsr write
		bcs ejj
		cpy #>buffsize
		beq lp

ejj		jsr $ffcc
		lda #1
		jmp $ffc3

		jmp start2
		.text "ide64shell"

buffer		.fill buffsize

arglist
