;
; hd.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; hd [file]
;;
;; 	Prints hexadecimal dump of file
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= 0

offset		= $fb

		.include "lib.asm"

banner		.null 13,"hexdump 0.1 by soci/singular",13

start2		ldx #<arglist
		ldy #>arglist
		jsr parseargs

		lda arglist
		ldx #<(arglist+1)
		ldy #>(arglist+1)
		jsr $ffbd
		lda #1
		ldx mydrive
		ldy #0
		sty offset
		sty offset+1
		sty offset+2
		jsr $ffba
		jsr $ffc0

loop		ldx #1
		jsr $ffc6

		ldx #0
-		jsr $ffcf
		ldy $90
		beq +
		cpy #$40
		bne mk
+		sta buffer,x
		inx
		bcs mk
		cpx #8
		blt -

mk		txa
		beq fin
		stx buffl
		tya
		pha

		ldx #3
		jsr $ffc9

		ldx #2
-		lda offset,x
		jsr hex
		dex
		bpl -

		ldy #0
-		lda #32
		jsr $ffd2
		cpy buffl
		blt +
		jsr $ffd2
		jsr $ffd2
		gcc e
+		lda buffer,y
		jsr hex
e		iny
		cpy #8
		blt -

		ldy #0
		lda #32
		jsr $ffd2
-		lda #1
		sta $d4
		lda buffer,y
		cmp #$0d
		beq d
		cmp #$8d
		bne +
d		lda #32
+		jsr $ffd2
		iny
		cpy buffl
		blt -
		lsr $d4
		lda #13
		jsr $ffd2
		lda $91
		cmp #$7f
		beq fin

		lda offset
		clc
		adc #8
		sta offset
		bcc +
		inc offset+1
		bne +
		inc offset+2
+
		pla
		beq loop

fin		jsr $ffcc
		lda #1
		jsr $ffc3
		jmp exit

hex		.proc
		pha
		lsr
		lsr
		lsr
		lsr
		jsr o
		pla
o		and #$0f
		cmp #10
		blt +
		adc #6
+		adc #$30
		jmp $ffd2
		.pend

		jmp start2
		.text "ide64shell"

buffer		.fill 8
buffl

arglist